;
;IDE64 manager ZIP plugin v1 quick hack by Soci/Singular
;must be compiled with 64tass 1.41
;
;The original non-hacked version is at http://www.cs.tut.fi/~albert/Dev/gunzip/


;ACPTR  = $ffa5
CHKIN  = $ffc6
CHKOUT = $ffc9
CHRIN  = $ffcf
CHROUT = $ffd2
;CIOUT  = $ffa8
CLOSE  = $ffc3
GETIN  = $ffe4
CLALL  = $ffe7
CLRCHN = $ffcc
;LISTEN = $ffb1
OPEN   = $ffc0
;SECOND = $ff93
SETLFS = $ffba
SETNAM = $ffbd
;TALK   = $ffb4
;TKSA   = $ff96
;UNLSN  = $ffae
;UNTLK  = $ffab

ST = $90

IDE64BlockWrite = $DEF1
IDE64BlockRead = $DEF4
IDE64BR = $6e ;$6e $6f
be	= $69 ;dc.b 0

;D2PRA  = $DD00		; c128 SERIAL PORT LOCATION
;CLKOUT = $10		; SLOW SERIAL CLOCK OUTPUT BIT MASK
;CLKIN  = $40		; SLOW SERIAL CLOCK INPUT BIT MASK
;D1ICR  = $DC0D		; 6526 cia INTERRUPT CONTROL REGISTER
;D1SDR  = $DC0C		; 6526 cia SERIAL DATA REGISTER


; =============================== C64 =====================================

CRC	= $6a	; b,c,d	;dc.b 255,255,255,255
crc32_tab0 = $3100
crc32_tab1 = $3200
crc32_tab2 = $3300
crc32_tab3 = $3400

; $cf00-cfff reserved for REU/ramdos

inBuf = $3000

PROGEND = $3000

buf32k	= $3500	; $3500-$cf00	bytes for the output/history buffer
bufsz	= $9a00	; must be at least $8100 bytes
		; (the Shrink method uses the end of the buffer for LZW
		;  tables, and needs at least one page for output)
	; We would need $ab00 bytes for 4-pass D64, $8900 for 5 passes

curplace = $14	; $15
bb	= $2		; bit bucket

bTmp	= $f7		; temporary pointer for functions
;	equ $f8
zp0	= $f9
zp1	= $fa
countLo	= $fb
countHi	= $fc
offset	= $fd
;	EQU $fe
lengths	= $9e		; for huffman table creation
;	EQU $9f
store	= $ff		; temporary storage

; Used ZP locations:	$02, $14-$15, $6a-$6f, $9e-$9f, $f7-$ff and $69 if in c64/128


;FASTSER = $02a3

	.comment
	*= $0801
	.byte $0b,8,$ef,0	; '239 SYS2061'
	.byte $9e,$32,$30,$36
	.byte $31,0,0,0
        .endc

        *=$1000
        clc
        bcc start
        stx IDE64BR
        sty IDE64BR+1
        sta inLen
        tay
        lda #0
        .byte $2c
ni      lda (IDE64BR),y
        sta inFile,y
        dey
        bpl ni
        lda $ba
        sta inDrive
        sec
start	php

; ========================================================================

;	cli	; in case..!?!?
	jsr prns
	.byte 154,147,142,9
	.byte $b0,$ae,$20,$20,$20,$20,$b0,$ae,$20,$b0,$ae,$20,$b0,$ae,$b0,$ae,$ae,$ae, 13
	.byte $7d,$ae,$7d,$7d,$ab,$ae,$ac,$be,$7d,$ab,$bd,$20,$7d,$20,$ab,$ae,$ad,$b3
	.byte "V1.11       19.11.2002"
	.byte $ad,$bd,$ad,$bd,$bd,$bd,$ad,$bd,$bd,$bd,$20,$be,$ad,$bd,$ad,$bd,$20,$bd
	.byte " BY PASI'ALBERT'OJALA", 13
	.byte "HTTP://WWW.CS.TUT.FI/%7EALBERT/", 13, 13, "MANAGER PLUGIN V1 BY SOCI/SINGULAR", 13, 13, 0

	lda #6
        sta $d020
        sta $d021
	ldx #0			; create the CRC32 table (makecrc.c)
crcg	lda #0
	sta CRC+3
	sta CRC+2
	sta CRC+1
	stx CRC+0
	ldy #8
g1	lsr CRC+3
	ror CRC+2
	ror CRC+1
	ror CRC+0
	bcc g0
	lda #$ed
	eor CRC+3
	sta CRC+3
	lda #$b8
	eor CRC+2
	sta CRC+2
	lda #$83
	eor CRC+1
	sta CRC+1
	lda #$20
	eor CRC+0
	sta CRC+0
g0	dey
	bne g1
	lda CRC+0
	sta crc32_tab0,x
	lda CRC+1
	sta crc32_tab1,x
	lda CRC+2
	sta crc32_tab2,x
	lda CRC+3
	sta crc32_tab3,x
	inx
	bne crcg
        
brlp    stx first
        lda #1
tx      lsr first
        rol
        bcc tx
        sta bitReverse,x
        inx
        bne brlp

;	jsr CheckIDE64
	lda #<inBuf
	sta IDE64BR+0
	lda #>inBuf
	sta IDE64BR+1
        
        .byte $2c
restart	clc
        php
	lda #0

;	sta inTrack
	;sta inSector
;	sta d64mode
	sta first

	sta gzip
	plp
        bcc idriveg
        lda #14
        sta chanf+1
        jsr askd
	bne bq
        
idriveg	jsr prns
	.byte "INPUT", 0

	lda #14		; channel #
	jsr askdrive
	beq idriveg
	sta inDrive

;	lda inDrive
;	ldx #14
;	jsr CheckBurst
;	sta inBurst

rfileg	jsr prns
	.byte "INPUT FILE?", 13, 34, 0

	lda #0
	sta inFile
	lda #<inFile
	ldx #>inFile
	ldy #28		; max filename length
	jsr getstr
	lda #0
	sta inFile,y
	sty inLen
	lda #34
	jsr OK_KEY

bq	jsr ReadDir
	lda inLen
	beq rfileg
	;lda inTrack	; allow non-existing files
	;beq rfile$

odriveg	jsr prns
	.byte "OUTPUT", 0

	lda #15
	jsr askdrive
	beq odriveg
	sta outDrive

;	lda outDrive
;	ldx #15
;	jsr CheckBurst
;	sta outBurst

;	lda inBurst
;	beq opening	; can't use burst read -> use sequential read
;	lda inTrack
;	bne vfs		; start t&s known, use burst read

;opening	
	ldx #<inFile
	ldy #>inFile
	lda inLen
	jsr SETNAM

	lda #2
	ldx inDrive
	ldy #0		; open 2,8,0,"fileName"
	jsr SETLFS
	jsr OPEN
;	inc inMode

	ldx #14
	jsr geterror
	cmp #0
	beq vfs

	jsr CLALL
	jsr CLRCHN
	ldx #<errorStr
	lda #>errorStr
	ldy errorLen
	jsr putstr
	jsr CR
	jmp restart

vfs	ldy #0
	sty be
	sty mode
	sty overwritemode

	lda #$36	; turn off BASIC ROM for good..
	sta 1


again	jsr InitBuffer32k
	jsr BYTEALIGN

	jsr Get2Bytes
	sty flags+0
	sta flags+1
	cpy #$1f
	beq ok1g
	cpy #$50
	bne mismatch2g
	cmp #$4b
	bne mismatch3g

	jsr Get2Bytes

	cpy #$30
	bne no0g
	cmp #$30
	beq again	; skip "PK00"
no0g
	cpy #$01	; end of Zip central directory ($50 $4b $05 $06)
	bne no1g
	cmp #$02
	beq centralg
no1g
	cpy #$03
	bne mismatch3g
	cmp #$04
	bne mismatch3g
	; Zip local file header $50 $4b $03 $04

	inc first	; got ID

	jmp ZipHeader


centralg
	jsr prns
	.byte "ZIP CENTRAL DIRECTORY REACHED", 13, 0
	jmp err		; Zip central directory ($50 $4b $03 $04)
	; end there


mismatch2g

;	lda first
;	bne mismatch3g
;	jmp checkD64

mismatch3g
	jmp mismatch



ok1g	cmp #$8b	; $1f $8b == GZIP ID
	bne mismatch2g


	inc first	; got ID

	inc gzip	; it's a gzip file (ID = $1f8b)
	jsr GetByte	; Compression method
	cmp #8
	beq ok3g

	pha
	jsr CLRCHN
	pla
	jsr puthex
	jmp nomethod

ok3g	jsr GetByte	; Flags
	sta flags
	and #$e0
	beq ok4g

	jsr prns
	.byte "UKNOWN FLAGS!", 13, 0

ok4g	jsr Get2Bytes	; Skip modification time (4 bytes)
	jsr Get2Bytes
	jsr Get2Bytes	; Skip extra flags and os (1 + 1 bytes)
	; byte 10

	lda flags
	and #4
	beq vx1

	; Skip extra field (3..32770 bytes)
	jsr Get2Bytes
	sty countLo
	sta countHi

vx2	jsr GetByte
	dec countLo
	bne vx2
	dec countHi
	bpl vx2

vx1	ldy #0		; filename character counter
	lda flags
	and #8
	beq vx3

	; Skip filename (NUL-terminated)
vx4	jsr GetByte
	cmp #"/"
	bne nopathg
pathg	ldy #0		; discard paths
	beq vx4
nopathg	cmp #":"
	beq pathg	; discard paths
	cmp #$60
	bcc okg
	and #$5f	; make it "lowercase"
	;ora #$80	; "uppercase" it
okg	sta fileName,y
	iny
	cmp #0
	bne vx4
	dey
vx3	sty fileLen

	lda flags
	and #16
	beq vx5		; Skip comment (NUL-terminated)

vx6	jsr GetByte
	tay	;cmp #0
	bne vx6

vx5	lda flags
	and #2
	beq vx7		; Skip CRC16
	jsr Get2Bytes
vx7
	lda #0
	ldy #3
clr0g	sta compSize,y	; compressed size
	sta uncSize,y	; uncompressed input size
	dey
	bpl clr0g

HandleFile

;	lda #0
;	sta d64mode
;d64sg

	jsr PrintFileName

	lda fileLen
	bne cc0g
	jmp skipitg

cc0g	lda mode
	cmp #"A"
	bne checkg

	lda #15
	sec
	sbc fileLen
	tay

spaceg	lda #" "
	jsr CHROUT
	dey
	bpl spaceg	; at least one space is printed
	jmp modeok2g

	; Check what the user wants to do with this!
checkg	ldy fileLen
	bne askg
	jmp skipitg	; no filename (directory), skip it

askg	jsr prns
	.byte " ",18,"Y",146,"ES ",18,"N",146,"O ",18,"A",146,"LL ",18,"E",146,"DIT ", 0


;	lda inDrive
;	cmp outDrive
;	bne diffg

	; same drive
;	lda #0		; mask away D,8
;	sta cmpdg+1

	jsr prns
	.byte "? ", 0
	jmp dagaing

editg	jsr OK_KEY
	lda #34
	jsr CHROUT

	lda #<fileName
	ldx #>fileName
	ldy #38		; max filename length
	jsr getstr
	lda #0
	sta fileName,y	; zero-terminate it again
	sty fileLen
	lda #34
	jsr CHROUT
	jmp checkg	; to the top!

	.comment
diffg

	lda #$ff	; enable D,8
	sta cmpdg+1
	jsr prns

	.byte "D",18,"8",146,"1 "
	.byte 18,"D",146,"64 ? ", 0
	.endc

dagaing	jsr getkey
	sta mode
	cmp #"Y"
	beq modeokg
	cmp #"N"
	beq modeokg
	cmp #"A"
	beq modeokg
	cmp #"E"
	beq editg
	cmp #3
	beq breakg	; handle ^C
	; TODO: change target drive

;cmpdg	and #$ff

;	cmp #"D"
;	beq d64g

;	cmp #"8"
;	beq d81g
	bne dagaing

;d81g	lda #8
;	.byte $2c	; bit $nnnn
;d64g	lda #4
;	sta d64mode

;	ldx #1
;	stx oTrack
;	dex
;	stx oSector

	; fall through!
modeokg	jsr CLRCHN
	lda mode
	jsr OK_KEY
modeok2g
	lda mode
	cmp #"N"	; skip it
	bne dog

skipitg	jsr prns
	.byte " SKIPPING..",13, 0
	jmp vx11

breakg	jsr CLALL
	jsr CLRCHN
	jsr CR
	jmp restart

dog

	.comment
	lda d64mode
	beq fileg	; filemode

	lda outBurst
	bne vx11		; can perform burst write -> do not open file

	ldx #<d64chan
	ldy #>d64chan
	lda #1
	jsr SETNAM
	lda #3
	ldx outDrive
	tay	;ldy #3		; open 3,8,3,"#"
	jsr SETLFS
	jsr OPEN

	ldx #15
	jsr geterror
	cmp #0
	bne err1g

	lda #"3"
	jsr initbp

	ldx #15
	jsr geterror
	cmp #0
	beq vx11
err1g	jmp diskerror
	.endc

fileg	; Open output file
	ldx #<fileName
	ldy #>fileName
	lda fileLen
	bne vx10
	ldx #<fileDef
	ldy #>fileDef
	lda #6		; 'stdout'
vx10	jsr SETNAM

	lda #3
	ldx outDrive
	ldy #1		; open 3,8,1,"fileName"
	jsr SETLFS
	jsr OPEN

	ldx #15
	jsr geterror
	cmp #0
	beq noerr4g

	pha
	lda #3
	jsr CLOSE
	jsr CLRCHN

	ldx #<errorStr
	lda #>errorStr
	ldy errorLen
	jsr putstr

	pla
	cmp #63		; check "FILE EXISTS" and ask for overwrite?
	bne ovbackg

	jsr overwrite
	beq fileg	; did scratch the file, try opening again
ovbackg	jmp checkg


noerr4g

vx11	ldx #3
loop11g	lda #0
	sta outSize,x
	lda #255
	sta CRC,x
	dex
	bpl loop11g

	lda gzip
	bne DeLoop

	lda method+0
	beq storedg
	cmp #8
	beq DeLoop	; method 8

	cmp #1		; shrink
	bne noshrg
	jsr Shrink
	jmp DeOut
noshrg	cmp #6
	bne noimpg

	jsr Implode
	lda ferr
	beq impokg
	jmp invalid	; invalid huffman tree
impokg	jmp DeOut

noimpg
	jsr Reduce
	jmp DeOut


storedg	jsr ZipStored
	jmp DeOut


	; End of header - check the block type and do it.
DeLoop	ldx #1
	jsr GetBits
	sta lastg+1
	ldx #2
	jsr GetBits
	cmp #1		; 0-1 -> CC
	beq vd10
	bcs vd9

	jsr Stored	; 0 == 0
	jmp lastg

vd9	jsr prns
	.byte "FIXHUF ", 0

	jsr Fixed	; 1 == 2 (bits not reversed)
	jmp lastg

vd10	jsr prns
	.byte "DYNHUF ", 0

	jsr Dynamic	; 2 == 1 (bits not reversed)
	lda ferr
	bne cont3

lastg	lda #0
	beq DeLoop	; Until last block

DeOut	jsr BYTEALIGN
	lda gzip
	bne cont1g	; GZip - always has the record

	lda flags+0
	and #8
	beq cont3	; Zip - does not have the record

	lda #<uncCRC	; get the descriptor
	ldy #>uncCRC
	jsr getcrc

	lda uncCRC+0
	cmp #$50
	bne cont3g
	lda uncCRC+1
	cmp #$4b
	bne cont3g
	lda uncCRC+2
	cmp #$07
	bne cont3g
	lda uncCRC+3
	cmp #$08
	bne cont3g

cont1g
	lda #<uncCRC
	ldy #>uncCRC
	jsr getcrc

cont3g	lda gzip
	bne cont2g	; GZip - does not have the record

	lda #<compSize
	ldy #>compSize
	jsr getcrc

cont2g
	lda #<uncSize
	ldy #>uncSize
	jsr getcrc

cont3	jsr FlushBuffer
	jsr InitBuffer32k

	lda mode
	cmp #"N"	; skip it
	beq file2g      ; did not open an output file


	.comment
	lda d64mode
	beq filegv      ; filemode

	lda outBurst
	bne i0g 	; can perform burst write -> did not open file

	lda #3
	jsr CLOSE

i0g     ldx #15
	jsr I0
	jmp file2g

filegv
	.endc

	lda #3
	jsr CLOSE

file2g  lda ferr
	bne invalid
	jsr prns
	.byte "SIZE ", 0

	lda #<outSize
	ldy #>outSize
	jsr showsize

	ldy #3
chkg    lda outSize,y
	cmp uncSize,y
	bne sizemismatch
	dey
	bpl chkg

	jsr CR

	ldx #3
chkcg   lda CRC+0,x
	eor #255
	sta CRC+0,x
	cmp uncCRC+0,x
	bne crcmismatch
	dex
	bpl chkcg
	jmp again

sizemismatch
	jsr prns
	.byte " WRONG ", 0

	lda #<uncSize
	ldy #>uncSize
	jsr showsize
	jsr CR
	jmp again

crcmismatch
	jsr prns
	.byte "CRC WRONG ", 0

	lda #<CRC
	ldy #>CRC
	jsr showsize

	lda #" "
	jsr CHROUT

	lda #<uncCRC
	ldy #>uncCRC
	jsr showsize
	jsr CR
	jmp again

invalid	; invalid huffman tree etc.
	jsr prns
	.byte "CORRUPT HUFFMAN TREE", 13, 0
	jmp err
mismatch	; magic number not $1f8b or compression method != 8
	jsr prns
	.byte "ID MISMATCH OR END OF FILE", 13, 0
;	jmp err
;diskerror
;	ldx #<errorStr
;	lda #>errorStr
;	ldy errorLen
;	jsr putstr
;	jsr CR

err

;	lda d64mode
;	bmi d64gx


;	lda inMode
;	beq d64gx; did not open the file -- used custom read


	lda #2
	jsr CLOSE	; close the input file

        jsr CLALL
	jsr CLRCHN

	lda #$37
	sta 1

	cli	; just in case
        lda #0
        sta 198
        jsr $ffe4
        beq *-3
	rts


getcrc	sta strg+1
	sty strg+2
	ldy #0
crc0g	jsr GetByte
strg	sta $aaaa,y
	iny
	cpy #4
	bne crc0g
	rts



overwrite
	lda overwritemode
	cmp #"A"
	beq scratchg

	jsr prns
	.byte "OVERWRITE? ", 18,"Y",146,"ES ",18,"N",146,"O ",18,"A",146,"LL ", 0

ow1g	jsr getkey
	cmp #"N"
	beq nog
	cmp #"Y"
	beq yg
	cmp #"A"
	bne ow1g

	sta overwritemode	; overwrite all
yg	jsr OK_KEY

scratchg
	ldx #15
	jsr CHKOUT
	lda #"S"
	jsr CHROUT
	lda #"0"
	jsr CHROUT
	lda #":"
	jsr CHROUT
	ldy #0
ow2g	lda ($bb),y
	jsr CHROUT
	iny
	cpy $b7
	bne ow2g
	jsr CLRCHN

	ldx #15
	jsr geterror
	ldx #<errorStr
	lda #>errorStr
	ldy errorLen
	jsr putstr
;yesg
	lda #0
	rts

nog	lda #1
	rts





ZipHeader
	jsr Get2Bytes	; version needed to extract

	jsr Get2Bytes
	sty flags+0
	sta flags+1	; general purpose bit flags
	; If bit 3 is set, data descriptor follows data

	jsr Get2Bytes
	sty method+0
	sta method+1	; compression method
	; 0 - stored
	; 8 - Deflate

	jsr Get2Bytes	; last mod file time
	jsr Get2Bytes	; last mod file date

	lda #<uncCRC
	ldy #>uncCRC
	jsr getcrc

	lda #<compSize
	ldy #>compSize
	jsr getcrc

	lda #<uncSize
	ldy #>uncSize
	jsr getcrc

	jsr Get2Bytes
	sty zfileLen+0
	sta zfileLen+1

	jsr Get2Bytes
	sty zextraLen+0
	sta zextraLen+1

	ldy #0
	inc zfileLen+0
	inc zfileLen+1
	jmp zc0g
zl0g	jsr GetByte
	cmp #"/"
	bne nopathe
pathgx  ldy #0		; discard paths
	beq zc0g
nopathe cmp #":"
	beq pathgx      ; discard paths
	cmp #$60
	bcc okgc
	and #$5f	; make it "lowercase"
	;ora #$80	; "uppercase" it
okgc    sta fileName,y
	iny
zc0g	dec zfileLen+0
	bne zl0g
	dec zfileLen+1
	bne zl0g
	lda #0
	sta fileName,y	; zero-terminate
	sty fileLen

	inc zextraLen+0
	inc zextraLen+1
	jmp zc1g
zl1g	jsr GetByte
zc1g	dec zextraLen+0
	bne zl1g
	dec zextraLen+1
	bne zl1g

	lda method+1
	bne nomeg
	lda method+0
	beq storedd
	cmp #8

	beq deflateg
	cmp #1
	beq shrinkg
	cmp #7
	bcs nomeg	; 2..5, 6 ok
shrinkg
implodeg
deflateg
storedd	jmp HandleFile


nomeg
	jsr PrintFileName

	;lda method+1
	;jsr puthex
	lda method+0
	jsr puthex

	lda flags+0
	and #8
	bne nomethod	; Zip - does have the record -> size not valid

	; just skip the unknown part..
	jsr prns
	.byte ": UNKNOWN METHOD - SKIP", 13, 0

	ldx #3
v2	inc compSize,x
	dex
	bpl v2
	jmp v1

v0	jsr GetByte
v1	dec compSize+0
	bne v0
	dec compSize+1
	bne v0
	dec compSize+2
	bne v0
	dec compSize+3
	bne v0
	jmp DeOut

	; TODO: skip until the next ZIP file header
nomethod
	jsr prns
	.byte ": UNKNOWN METHOD", 13, 0
	jmp err


PrintFileName
	jsr CLRCHN
	lda #34
	jsr CHROUT	; "
	ldx #<fileName
	lda #>fileName
	ldy fileLen
	jsr putstr
	lda #34
	jmp CHROUT


Stored	jsr BYTEALIGN
	jsr Get2Bytes
	sty compSize+0
	sta compSize+1
	lda #0
	sta compSize+2
	sta compSize+3

	jsr GetByte
	eor #255
	eor compSize+0
	beq t1
	jmp err

t1	jsr GetByte
	eor #255
	eor compSize+1
	beq ZipStored
	jmp err
	;jmp ZipStored

ZipStored .proc
	jsr prns
	.byte "STORED ", 0

	ldx #3
loopf	inc compSize,x
	dex
	bpl loopf
	bmi b1

b0	jsr GetByte
	jsr PutBuffer
b1	dec compSize+0
	bne b0
	dec compSize+1
	bne b0
	dec compSize+2
	bne b0
	dec compSize+3
	bne b0
	rts
        .pend

Get2Bytes
	jsr GetByte
	tay
	jmp GetByte


	;  Out	Input pattern	Input
	;  256	0000000		0
	;  :	:     :
	;  279	0010111		23
	;  0	00110000	48
	;  :	:      :
	;  143	10111111	191
	;  280	11000000	192
	;  :	:      :
	;  287	11000111	199
	;  144	110010000	400
	;  :	:       :
	;  255	111111111	511
	;  Note the bit order!

; Fixed Huffman decode -- 59 bytes (UnZip: 98 bytes)
Fixed	ldx #7
	jsr GetBits	; Reverse default bit order
	cmp #24
	bcc c023
			; 24..127
	jsr GetBit
	rol		; 48..255
	cmp #200
	bcc c48199
	; 200..255
	;sec
	sbc #128	; 72..127
	jsr GetBit
	rol		; 144..255
c0	jsr PutBuffer	; 0..143 & 144..255
	jmp Fixed	; continue loop

c48199	;clc		; 48..199
	sbc #47		; 0..151
	cmp #144
	bcc c0
			; 144..151
	;sec
	adc #135	; 280..287 (24..31)
	bcs lz77g

c023	cmp #0		; 0..23 -> 256..279
	bne lz77g
	rts		; 256 == EOF

lz77g	jsr GetLen	; 1..23
	ldx #5
	jsr GetBits	; reverse default bit order
	jsr CopyLz
	jmp Fixed



GetLen	tay	; j
	;dey	; 1..23 -> 0..22
	sty store
	ldx cplext-1,y
	jsr READBITS	; 0..5 bits
	;clc
	adc #3		; does not overflow
	ldy store
	adc cplens_3-1,y	; 0..255 may overflow
	sta countLo
	lda #0
	rol		;adc #0
	sta countHi
	rts


	; cpdist-index in A
	; offset in "offset"
	; length in countLo & countHi
CopyLz	sta store
	tay
	ldx cpdext,y
	cpx #9
	bcs v913
	jsr READBITS	; 1..8 bits
	sta offset+0
	lda #0
	jmp ovg
v913	stx xg+1
	ldx #8		; 9..13 bits
	jsr READBITS
	sta offset+0
xg	lda #9
	and #7
	tax
	jsr READBITS
ovg	sta offset+1
	ldy store
	lda cpdistLo,y
	;clc		; READBITS cleared it (either one)
	adc offset+0
	sta offset+0
	lda cpdistHi,y
	adc offset+1
	sta offset+1

	; Entry-point for Implode/Reduce
CopyLz2	lda outCmd+1	; low-byte of current output position
	sec
	sbc offset+0
	sta offset+0
	lda outCmd+2	; high-byte of current output position
	sbc offset+1
	bcc buffixg	; wrapped below 0, must be out of buffer -> fix
	cmp #>buf32k
	bcs bufokg	; not below 0 and not below buffer start -> ok
	; not below 0 but below buffer start -> fix
buffixg	;clc		; C is clear in both entries
	adc #>bufsz
bufokg	sta offset+1

	; change dec;lda;cmp #255;bne -> dec;bne
	inc countLo
	inc countHi
	jmp l3g

l0g
	ldy #0
	lda (offset),y
	jsr PutBuffer
	inc offset+0
	bne l3g
	ldy offset+1
	iny
	cpy #>(buf32k+bufsz)	; wrap to the start of the (ring)buffer
	bne l2g
	ldy #>buf32k
l2g	sty offset+1
l3g	dec countLo
	bne l0g
	dec countHi
	bne l0g
	rts


Dynamic	ldx #5
	jsr READBITS
	;clc
	adc #1
	sta literalCodes+0	; + 257
	lda #1
	sta literalCodes+1
	ldx #5
	jsr READBITS
	;clc
	adc #1
	sta distCodes		; + 1

	ldx #4
	jsr READBITS
	;clc
	adc #4
	sta countLo
	lda #0
	sta countHi

	;lda #0
	ldx #19
b0	sta codelens,x
	dex
	bpl b0

b1	ldx #3
	jsr READBITS
	ldy countHi
	ldx border,y
	sta codelens,x
	inc countHi
	dec countLo
	bne b1

	; Create a decode tree that is in (Places)
	; Number of values in A(lo) and Y(hi)
	; Length table pointer in (lengths)
	lda #<distanceTree
	sta Places+0
	lda #>distanceTree
	sta Places+1
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1
	ldy #0
	lda #19
	jsr CreateTree
	beq tok1b
	; invalid tree
	rts

	;
tok1b	lda literalCodes+0
	clc
	adc distCodes
	sta countLo
	lda literalCodes+1
	adc #0
	sta countHi
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1

b5	lda #<distanceTree	; bitlen decode 117 bytes (UnZip 173 bytes)
	ldy #>distanceTree
	jsr DecodeValue

	cmp #16
	beq b16
	bcc b015
	; j>16

	cmp #17
	beq b17

	ldx #7
	jsr READBITS
	;clc
	adc #11
	jmp b8

b17	ldx #3
	jsr READBITS
	;clc
	adc #3

b8	tax
	ldy #0
	tya	;lda #0
b9	sta (lengths),y
	inc lengths+0
	bne l0b
	inc lengths+1
l0b	dec countLo
	bne l1b
	dec countHi
l1b	dex
	bne b9
	jmp b6


b16	; j==16
	ldx #2
	jsr READBITS
	;clc
	adc #3
	tax

	dec lengths+1
	ldy #255
b7	lda (lengths),y		; lengths[i-1]
	inc lengths+0
	bne l2b
	inc lengths+1
l2b	sta (lengths),y		; lengths[i]
	dec countLo
	bne l3b
	dec countHi
l3b	dex
	bne b7
	inc lengths+1
	jmp b6

b015	; j<16
	ldy #0
	sta (lengths),y
	inc lengths+0
	bne l4b
	inc lengths+1
l4b	dec countLo
	bne b6
	dec countHi

b6	lda countHi
	bpl b5

	; Create a decode tree that is in (Places)
	; Number of values in A(lo) and Y(hi)
	; Length table pointer in (lengths)
	lda #<literalTree
	sta Places+0
	lda #>literalTree
	sta Places+1
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1
	ldy literalCodes+1
	lda literalCodes+0
	jsr CreateTree
	beq tok2g
	; invalid tree
	rts

	; Create a decode tree that is in (Places)
	; Number of values in A(lo) and Y(hi)
	; Length table pointer in (lengths)
tok2g	lda #<distanceTree
	sta Places+0
	lda #>distanceTree
	sta Places+1
	lda #<codelens
	clc
	adc literalCodes+0
	sta lengths+0
	lda #>codelens
	adc literalCodes+1
	sta lengths+1
	ldy #0
	lda distCodes
	jsr CreateTree
	beq loop
	; invalid tree
	rts

literal	jsr PutBuffer

loop	lda #<literalTree
	ldy #>literalTree
	jsr DecodeValue
	bcc literal
	;cmp #0
	beq eofg

	jsr GetLen
	lda #<distanceTree
	ldy #>distanceTree
	jsr DecodeValue

	; cpdist-index in A
	; pre-offset in "offset"
	; length in countLo & countHi
	jsr CopyLz
	jmp loop
eofg	rts




;--------------- D64 -> DISK ------------------------
	.comment
mismatch3
	jmp mismatch
checkD64	; Is it uncompressed D64?
	lda d64mode
	bmi mismatch3	; one-drive D64 mode selected -> can't be
	lda fdos
	cmp #"A"
	beq mismatch3	; a 1541-format disk -> can't be

	jsr prns
	.byte "IS THIS A NON-COMPRESSED D64? ", 18,"Y",146,"ES ",18,"N",146,"O ", 0

againg	jsr getkey
	cmp #"N"
	beq mismatch3
	cmp #"Y"
	bne againg

	jsr CHROUT
	jsr prns
	.byte 13, "WRITE D64 TO DISK? ", 18,"Y",146,"ES ",18,"N",146,"O ", 0

again2g	jsr getkey
	cmp #"N"
	beq mismatch3
	cmp #"Y"
	bne again2g

	jsr OK_KEY

	lda outBurst
	bne n11		; can perform burst write -> do not open file

	ldx #<d64chan
	ldy #>d64chan
	lda #1
	jsr SETNAM
	lda #3
	ldx outDrive
	ldy #3		; open 3,8,3,"#"
	jsr SETLFS
	jsr OPEN

	ldx #15
	jsr geterror
	cmp #0
	beq noerr2n
	jmp diskerror
noerr2n
	lda #"3"
	jsr initbp

	ldx #15
	jsr geterror
	cmp #0
	beq noerr3n
	jmp diskerror
noerr3n


n11	lda #4
	sta d64mode
	ldx #1
	stx oTrack
	dex
	stx oSector

	lda #2+1
	sta countHi
	lda #$ab+0	; 683 sectors
	sta countLo

	jsr InitBuffer32k

	lda flags+0
	jsr PutBuffer
	lda flags+1
	jsr PutBuffer

	ldy #2
d64loopn
	jsr GetByte
	jsr PutBuffer
	iny
	bne d64loopn
	dec countLo
	bne d64loopn
	dec countHi
	bne d64loopn

	jsr FlushBuffer



	lda outBurst
	bne i0n		; can perform burst write -> did not open file

	lda #3
	jsr CLOSE

i0n	ldx #15
	jsr I0


	jsr prns
	.byte "SIZE: ", 0

	lda #<outSize
	ldy #>outSize
	jsr showsize
	jsr CR

	jsr CLALL
	jsr CLRCHN


	jmp err		; leave
	.endc





;--------------- Implode (method 6) ------------------------
minMatchLen
	.byte 2

DecodeSF .proc       		; can change ROM
	jsr GetByte
	sta countLo
	inc countLo
	ldy #0

loop	jsr GetByte
	pha
	lsr
	lsr
	lsr
	lsr
	tax
	pla
	and #15
	clc
	adc #1
loop1	sta codelens,y
	iny
	dex
	bpl loop1
	dec countLo
	bne loop
	rts
	.pend

Implode .proc
	jsr prns
	.byte "IMPLODED", 13, 0

	; initialize the history buffer to 0
	jsr ClearBuffer

	lda #2
	sta minMatchLen
	jsr BYTEALIGN
	lda flags+0
	and #4
	beq noLitTreef

	lda #3
	sta minMatchLen
	jsr DecodeSF			; can change ROM

	; Create a decode tree that is in (Places)
	; Number of values in A(lo) and Y(hi)
	; Length table pointer in (lengths)
	lda #<literalTree
	sta Places+0
	lda #>literalTree
	sta Places+1
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1
	ldy #1	; 256 literals
	lda #0
	jsr CreateTree
	beq tok1f
	; invalid tree
	rts
tok1f
noLitTreef
	jsr DecodeSF			; can change ROM

	lda #<impLengthTree
	sta Places+0
	lda #>impLengthTree
	sta Places+1
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1
	ldy #0
	lda #64
	jsr CreateTree
	beq tok2f
	; invalid tree
	rts

tok2f	jsr DecodeSF			; can change ROM

	lda #<distanceTree
	sta Places+0
	lda #>distanceTree
	sta Places+1
	lda #<codelens
	sta lengths+0
	lda #>codelens
	sta lengths+1
	ldy #0
	lda #64
	jsr CreateTree
	beq tok3f
	; invalid tree
	rts
tok3f
impLoopf
	ldx #3
f0	lda outSize+0,x
	cmp uncSize+0,x
	bcc loopItf	; SIZE < size
	;bne loopIt$
	dex
	bpl f0
	rts
loopItf
	jsr GetBit
	bcs literalf
	; lz77
	lda flags+0
	and #2
	beq dict4kf
	; dict8k
	ldx #7
	jsr READBITS
	asl
	sta offset+0
	lda #<distanceTree
	ldy #>distanceTree
	jsr DecodeSFValue		; can change ROM
	jmp dictokf
dict4kf
	ldx #6
	jsr READBITS
	asl
	asl
	sta offset+0
	lda #<distanceTree
	ldy #>distanceTree
	jsr DecodeSFValue		; can change ROM
	lsr
	ror offset+0
dictokf
	lsr
	ror offset+0
	sta offset+1
	inc offset+0
	bne dok2f
	inc offset+1
dok2f
	lda #0
	sta countHi
	lda #<impLengthTree
	ldy #>impLengthTree
	jsr DecodeSFValue		; can change ROM
	sta countLo
	cmp #63
	bne lenokf
	ldx #8
	jsr READBITS
	;clc
	adc countLo
	sta countLo
	bcc lenokf
	inc countHi
lenokf	lda minMatchLen
	clc
	adc countLo
	sta countLo
	bcc lenok2f
	inc countHi
lenok2f
	jsr CopyLz2	; offset in (offset), length in countLo/Hi
	jmp impLoopf

literalf
	lda flags+0
	and #4
	beq get8f

	lda #<literalTree
	ldy #>literalTree
	jsr DecodeSFValue		; can change ROM
	jmp litokf

get8f	ldx #8
	jsr READBITS
litokf	jsr PutBuffer
	jmp impLoopf
	.pend

;--------------- Shrink (method 1) - lzw ---------------------

codesize
	.byte 0
KwKwK
	.byte 0

code
	.word 0
oldcode
	.word 0
freecode
	.word 0
curcode
	.word 0

ReadCode
	ldx #8
	jsr READBITS
	sta code+0
	ldx codesize	; it is at least 1
	jsr READBITS
	sta code+1	; MSB
	rts

CodeToOldcode
	lda code+0
	sta oldcode+0
	lda code+1
	sta oldcode+1
	rts

Shrink
	jsr prns
	.byte "SHRINK ", 0

	ldx #1
	stx codesize
	stx freecode+1
	dex	; X = 0
	stx freecode+0

	; Parent[] at buf32kEnd - 16384 (lo) / buf32kEnd - 8192 (hi)
	; Value[] at buf32kEnd - 24576
	; Stack[] at buf32kEnd - 32768

	; for (code=0; code < BOGUSCODE /*256*/; code++) {
	;ldx #0
w0	txa
	sta buf32k+bufsz-24576,x	; Value[code] = code
	lda #0
	sta buf32k+bufsz-16384,x	; Parent[code] lo
	lda #1
	sta buf32k+bufsz-8192,x		; Parent[code] = BOGUSCODE/*256*/
	inx
	bne w0

	; for (code = BOGUSCODE+1; code < HSIZE; code++)
	;   Parent[code] = FREE_CODE
	lda #<(buf32k+bufsz-8192+257)
	sta zp0
	lda #>(buf32k+bufsz-8192+257)
	sta zp1		; Parent[BOGUSCODE+1] hi

	lda #<(8192-257+1)
	sta countLo
	lda #>(8192-257+256)
	sta countHi

	ldy #0
	;inc countLo
	;inc countHi
	lda #$20	; FREE_CODE -- only hi byte matters
	jmp w2

w1	sta (zp0),y
	iny
	bne w2
	inc zp1
w2	dec countLo
	bne w1
	dec countHi
	bne w1


	; oldcode = READBITS(8)
	; oldcode |= (READBITS(codesize)<<8)

	jsr ReadCode
	jsr CodeToOldcode

	; if (SIZE < size) {
	;   ADDBUFFER(oldcode, outfp)

	ldx #3
w3	lda outSize+0,x
	cmp uncSize+0,x
	bcc canAddw	; SIZE < size
	dex
	bpl w3
	rts
canAddw
	lda oldcode+0
	jsr PutBufferLzw

	; while (SIZE < size) {
shrinkLoopw
	ldx #3
w4	lda outSize+0,x
	cmp uncSize+0,x
	bcc loopItw	; SIZE < size
	dex
	bpl w4
	rts
loopItw

	; code = READBITS(8)
	; code |= (READBITS(codesize)<<8)

	jsr ReadCode

	; if (code == BOGUSCODE) {   /* possible to have consecutive escapes? */
	;lda code+1
	cmp #1
	beq chkw
nobw	jmp noBogusw
chkw	lda code+0
	bne nobw
	; code == BOGUSCODE /*256*/

	; code = READBITS(8)
	; code |= (READBITS(codesize)<<8)

	jsr ReadCode
	;lda code+1
	cmp #0
	bne shrinkLoopw
	lda code+0
	cmp #1
	bne notOnew
	inc codesize	; codesize++
	jmp shrinkLoopw
notOnew	cmp #2
	bne shrinkLoopw

	; /* clear leafs (nodes with no children) */

	; /* first loop:  mark each parent as such */
	lda #<(buf32k+bufsz-16384+257)
	sta bTmp+0
	lda #>(buf32k+bufsz-16384+257)
	sta bTmp+1	; Parent[BOGUSCODE+1] lo
	lda #<(buf32k+bufsz-8192+257)
	sta zp0
	lda #>(buf32k+bufsz-8192+257)
	sta zp1		; Parent[BOGUSCODE+1] hi

	lda #<(8192-257+1)
	sta countLo
	lda #>(8192-257+256)
	sta countHi

	ldy #0
	;inc countLo
	;inc countHi
	jmp w92

	; for (code = BOGUSCODE+1;  code < HSIZE;  ++code) {
	;   curcode = (Parent[code] & CODE_MASK)
w91	lda (zp0),y	; Parent[] hi
	and #$1f
	beq w93	; <BOGUSCODE
	cmp #1
	bne w94	; >BOGUSCODE
	lda (bTmp),y	; Parent[] lo
	beq w93	; ==BOGUSCODE

	; if (curcode > BOGUSCODE)
	;   Parent[curcode] |= HAS_CHILD
w94	lda (bTmp),y
	clc
	adc #<(buf32k+bufsz-8192)	; Parent[] hi
	sta offset+0
	lda (zp0),y
	and #$1f
	adc #>(buf32k+bufsz-8192)
	sta offset+1
	sty yw+1
	ldy #0
	lda (offset),y
	ora #$40	; HAS_CHILD
	sta (offset),y
yw	ldy #0

w93	iny
	bne w92
	inc bTmp+1
	inc zp1

w92	dec countLo
	bne w91
	dec countHi
	bne w91


	; /* second loop:  clear all nodes *not* marked as parents; reset flag bits */
	lda #<(buf32k+bufsz-8192+257)
	sta zp0
	lda #>(buf32k+bufsz-8192+257)
	sta zp1		; Parent[BOGUSCODE+1] hi

	lda #<(8192-257+1)
	sta countLo
	lda #>(8192-257+256)
	sta countHi

	ldy #0
	;inc countLo
	;inc countHi
	jmp w82

	; for (code = BOGUSCODE+1;  code < HSIZE;  ++code) {
	;   if (Parent[code] & HAS_CHILD) {   /* just clear child-bit */
	;     Parent[code] &= ~HAS_CHILD
w81	lda (zp0),y	; Parent[] hi
	and #$40
	beq freew
	lda (zp0),y
	and #$3f
	jmp w83

	;   } else {                              /* leaf:  lose it */
	;     Parent[code] = FREE_CODE
freew	lda #$20
	; low part does not matter

w83	sta (zp0),y
	iny
	bne w82
	inc bTmp+1
	inc zp1
w82	dec countLo
	bne w81
	dec countHi
	bne w81

	; freecode = BOGUSCODE
	ldx #0
	stx freecode+0
	inx
	stx freecode+1
	jmp shrinkLoopw

noBogusw
	; newstr = &Stack[HSIZE-1]
	lda #<(buf32k+bufsz-32768+8191)
	sta bTmp+0
	lda #>(buf32k+bufsz-32768+8191)
	sta bTmp+1	; &Stack[8192-1]

	lda #0
	sta KwKwK	; KwKwK = 0
	sta countLo
	sta countHi	; len = 0

	; if (Parent[curcode = code] == FREE_CODE) {
	lda code+0
	sta curcode+0
	clc
	adc #<(buf32k+bufsz-8192)	; Parent[] hi
	sta getw+1
	lda code+1
	sta curcode+1
	adc #>(buf32k+bufsz-8192)
	sta getw+2
getw	lda $aaaa
	cmp #$20	; low part does not matter
	bne noKwKwKw

	inc KwKwK	; KwKwK = 1
	inc countLo	; len = 1

	lda bTmp+0	; newstr--
	bne ovw
	dec bTmp+1
ovw	dec bTmp+0

	lda oldcode+0	; curcode = oldcode
	sta curcode+0
	lda oldcode+1
	sta curcode+1
noKwKwKw

	; do {
	;   *newstr-- = Value[curcode]
	;   len++
	;   curcode = (Parent[curcode] & CODE_MASK)
	; } while (curcode != BOGUSCODE)
doLoopw	lda #<(buf32k+bufsz-24576)
	clc
	adc curcode+0
	sta zp0
	lda #>(buf32k+bufsz-24576)
	adc curcode+1
	sta zp1
	ldy #0
	lda (zp0),y
	sta (bTmp),y	; *newstr = Value[curcode]

	lda bTmp+0
	bne ov2w
	dec bTmp+1
ov2w	dec bTmp+0	; newstr--

	inc countLo	; len++
	bne ov3w
	inc countHi
ov3w
	lda zp1
	clc
	adc #>8192
	sta zp1		; Value[curcode] -> Parent[curcode] lo
	lda (zp0),y
	sta curcode+0
	lda zp1
	clc
	adc #>8192
	sta zp1		; Parent[curcode] lo -> hi
	lda (zp0),y
	and #$1f
	sta curcode+1	; curcode = (Parent[curcode] & CODE_MASK)


	cmp #1
	bne doLoopw
	lda curcode+0
	bne doLoopw	; } while (curcode != BOGUSCODE)

	inc bTmp+0
	bne ov4w
	inc bTmp+1	; newstr++
ov4w

	; if (KwKwK)
	;   Stack[HSIZE-1] = *newstr
	lda KwKwK
	beq noKwKwK2w

	lda #<(buf32k+bufsz-32768+8191)
	sta zp0
	lda #>(buf32k+bufsz-32768+8191)
	sta zp1
	lda (bTmp),y
	sta (zp0),y

noKwKwK2w
	; do {
	;   freecode++
	; } while (Parent[freecode] != FREE_CODE)
doLoop2w
	inc freecode+0
	bne ov5w
	inc freecode+1
ov5w	lda #<(buf32k+bufsz-8192)	; Parent[freecode] hi
	clc
	adc freecode+0
	sta zp0
	lda #>(buf32k+bufsz-8192)
	adc freecode+1
	sta zp1
	lda (zp0),y
	cmp #$20	; low part does not matter
	bne doLoop2w

	; Parent[freecode] = oldcode
	; Value[freecode] = *newstr
	; oldcode = code

	lda oldcode+1
	sta (zp0),y	; Parent[freecode] hi
	lda zp1
	sec
	sbc #>8192
	sta zp1
	lda oldcode+0
	sta (zp0),y	; Parent[freecode] lo
	lda zp1
	sec
	sbc #>8192
	sta zp1
	lda (bTmp),y
	sta (zp0),y	; Value[freecode]

	jsr CodeToOldcode

	; while (len--) {
	;   ADDBUFFER(*newstr, outfp)
	;   newstr++
	; }
	lda bTmp+0
	sta putaw+1
	lda bTmp+1
	sta putaw+2
	inc countLo
	inc countHi
	jmp ov6w

putaw	lda $aaaa
	jsr PutBufferLzw	; flushes at the right place
	inc putaw+1
	bne ov6w
	inc putaw+2
ov6w	dec countLo
	bne putaw
	dec countHi
	bne putaw

	jmp shrinkLoopw





	; Does not need to preserve Y
PutBufferLzw .proc
	jsr PutBuffer	; Can switch ROM/RAM
	lda outCmd+2
	cmp #>(buf32k+bufsz-32768)
	bne w2
	jsr FlushBuffer
	jsr InitBuffer32k	; jsr + rts
w2	rts
	.pend




;--------------- Reduce (methods 2-5) ------------------------

B	.byte 0
	.byte 1,1,2,2,3,3,3,3, 4,4,4,4,4,4,4,4
	.byte 5,5,5,5,5,5,5,5, 5,5,5,5,5,5,5,5
	.byte 6	;,6,6,6,6,6,6,6, 6,6,6,6,6,6,6,6
		;dc.b 6,6,6,6,6,6,6,6, 6,6,6,6,6,6,6,6
lastC	.byte 0
state	.byte 0

Reduce
	jsr prns
	.byte "REDUCE ", 0

	lda method+0
	clc
	adc #47
	jsr OK_KEY

	; initialize the history buffer to 0
	jsr ClearBuffer
	jsr BYTEALIGN

	; for (j=255; j>=0; j--) {
	;   N[j] = READBITS(6)
	;   if (N[j] > 32) {
	;     fprintf(errfp, "Follower set %d too large: %d\n", j, N[j])
	;     N[j] = 32
	;   }
	;   for (i=0; i<N[j]; i++) {
	;     S[j][i] = READBITS(8)
	;   }
	; }

	lda #<S
	sta bTmp+0
	lda #>S
	sta bTmp+1

	lda #255
	sta countHi

fLoops	ldy countHi
	lda bTmp+0
	sta SPtrLo,y
	lda bTmp+1
	sta SPtrHi,y
	ldx #6
	jsr READBITS
	ldy countHi
	sta N,y
	cmp #0
	beq fNexts
	cmp #33
	bcc fOks
	inc ferr
	rts

fOks	sta countLo
fILs	ldx #8
	jsr READBITS
	ldy #0
	sta (bTmp),y
	inc bTmp+0
	bne ptrOks
	inc bTmp+1
ptrOks	dec countLo
	bne fILs
fNexts	dec countHi
	ldy countHi
	cpy #255
	bne fLoops

	lda #>SPtrLo
	cmp bTmp+1
	bcc badFollowers	; HI >
	bne okFollowers		; HI <
	lda #<SPtrLo
	cmp bTmp+0
	bcs okFollowers		; LO <=
badFollowers
	jsr prns
	.byte "FOLLOWER OVERRUN", 0
	inc ferr
	rts

okFollowers
	lda #0
	sta lastC	; lastC = 0
	sta state	; state = 0

	; while (SIZE < size) {
reduceLoops
	ldx #3
s4	lda outSize+0,x
	cmp uncSize+0,x
	bcc loopIts	; SIZE < size
	dex
	bpl s4
	rts
loopIts
	ldy lastC
	lda N,y
	bne mores	; if (!N[lastC]) {
get8s	ldx #8
	jsr READBITS	;   c = READBITS(8)
	jmp states
mores			; } else {
	jsr GetBit	;   if (READBITS(1)) {
	bcs get8s	;     c = READBITS(8)
			;   } else {
	ldx N,y
	lda B,x
	tax
	jsr READBITS
	ldy lastC
	clc
	adc SPtrLo,y
	sta bTmp+0
	lda #0
	adc SPtrHi,y
	sta bTmp+1
	ldy #0
	lda (bTmp),y	;     c = S[lastC][READBITS(B[N[lastC]])]
			;   }
			; }
states	sta lastC	; lastC = c
	ldx state	; switch (state) {
	bne not0s	; case 0:

	cmp #144	;   if (c != 144)
	beq incss
	jsr PutBuffer	;     ADDBUFFER(c, outfp)
	jmp reduceLoops	;   else
incss	inc state	;     state = 1
	jmp reduceLoops	;   break

not0s	cpx #1
	bne not1s	; case 1:
	cmp #0
	beq add144s	;   if (c) {
	inc state
	ldx #0
	stx offset+1
	stx offset+0

	ldx method+0
	cpx #2		;     switch(level) {
	bne lnot2s	;     case 2:
	asl		;       dist = (c >> 7)*256
	rol offset+1	;       len = 0x7f & c
	lsr
	cmp #127	;       state = (len == 0x7f)?2:3
	jmp chks	;	break

lnot2s	cpx #3
	bne lnot3s	;     case 3:
	tax		;       dist = (c >> 6)*256
	asl		;       len = 0x3f & c
	rol offset+1	;       state = (len == 0x3f)?2:3
	asl
	rol offset+1
	txa
	and #63
	cmp #63
	jmp chks	;       break

lnot3s	cpx #4
	bne lnot4s	;     case 4:
	tax		;       dist = (c >> 5)*256
	lsr		;       len = 0x1f & c
	lsr		;       state = (len == 0x1f)?2:3
	lsr
	lsr
	lsr
	sta offset+1
	txa
	and #31
	cmp #31
	jmp chks	;       break

lnot4s	tax		;     case 5:
	lsr		;       dist = (c >> 4)*256
	lsr		;       len = 0x0f & c
	lsr		;       state = (len == 0x0f)?2:3
	lsr		;       break
	sta offset+1
	txa
	and #15
	cmp #15

chks	beq s2		;     }
	inc state
s2	sta countLo
	lda #0
	sta countHi
	jmp reduceLoops

add144s	sta state	;   } else {
	lda #144	;     state = 0
	jsr PutBuffer	;     ADDBUFFER(144, outfp)
	jmp reduceLoops	;   }
			;   break

not1s	cpx #2
	bne not2s	; case 2:
	clc		;   len += c
	adc countLo
	sta countLo
	lda countHi
	adc #0
	sta countHi
	inc state	;   state = 3
	jmp reduceLoops	;   break

not2s	sec		; case 3:
	adc offset+0	;   dist += c + 1
	sta offset+0
	lda offset+1
	adc #0
	sta offset+1
	lda countLo
	clc
	adc #3
	sta countLo	;   len += 3
	lda countHi
	adc #0
	sta countHi
	jsr CopyLz2
	;    while(len--) {
	;	int c = buf32k[(bIdx - dist) & 0x7fff]
	;	ADDBUFFER(c, outfp)
	;    }
	;    state = 0
	;    break
	;}
	lda #0
	sta state
	jmp reduceLoops
    ;}
    ;FLUSHBUFFER(outfp)

    ;BYTEALIGN()
    ;return 0
;}



;--------------- Bit/byte input routines ---------------------


BYTEALIGN	; flush bit bucket
	lda #1
	sta bb
	rts


GetByte	ldx be	; get byte	-- can change ROM
	beq readblkm

readm	inc be
	lda inBuf,x
	rts

readblkm

	.comment
	lda inBurst
	beq stdm	; can't use burst read -> faster to do it sequentially
	lda inTrack
	beq stdm
	; can use burst and t&s known -> use burst read
	jsr BREAD
	lda status
	and #15
	cmp #2
	bcc m1
	ldx inTrack
	lda inSector
	jsr BERR
m1
	lda inBuf+0	; copy links for next read
	sta inTrack
	lda inBuf+1
	sta inSector

	ldx #2
	stx be
	bne readm
	.endc

;stdm 
	ldx #2
	jsr CHKIN


;	lda IDE64present
;	bpl fillm	; IDE64 not found
	tya
	pha
	lda #IDE64BR
	ldx #0
	ldy #1
	inc $d020
	jsr IDE64BlockRead
	pla
	tay
	bcc IDE64readbackm

        ldx #2
	jsr CHKIN

fillm	jsr CHRIN
	ldx be
	sta inBuf,x

	sta $d020

	inc be
	bne fillm

IDE64readbackm

	jsr CLRCHN
	ldx #0
	jmp readm

GetBit	.proc
	lsr bb		; get a bit from bit bucket
	beq v1
	rts
v1	sta av+1	; it is empty -> fill it
	stx xv+1
	jsr GetByte
xv	ldx #0
	sec		; insert full marker
	ror
	sta bb
av	lda #0
	rts
	.pend

GetBits	.proc
	lda #0		;2	; Reverse the order by not reversing the result..
v1	dex		;2
	bmi v0		;2/3
	lsr bb		;5
	bne v2		;2/3
	sta av+1
	stx xv+1
	jsr GetByte
xv	ldx #0
	sec
	ror
	sta bb
av	lda #0
v2	rol		;2
	jmp v1		;3
v0	rts		;19+ 17*#bits
	.pend


READBITS .proc       ; Read X bits from the input, in Gzip order, returns C clear
	stx jv+1	;4

	lda #0
v1	dex
	bmi v0
	lsr bb
	bne v2
	sta av+1
	stx xv+1
	jsr GetByte
xv	ldx #0
	sec
	ror
	sta bb
av	lda #0
v2	rol
	jmp v1
v0			;7+17*#bits
	; reverse bit pattern
	; worst-case 25 cycles (0 bits), best-case 11 cycles (8 bits)
	tay			;2
	lda bitReverse,y	;4
	; Logical shift right A by 8-X positions (X=0..8)
	clc			;2
jv	bcc jv+2		;3
	lsr	; 0 -> 8 shifts
	lsr	; 1 -> 7 shifts
	lsr	; 2 -> 6 shifts
	lsr	; 3 -> 5 shifts
	lsr	; 4 -> 4 shifts
	lsr	; 5 -> 3 shifts
	lsr	; 6 -> 2 shifts
	lsr	; 7 -> 1 shifts
	rts	; 8 -> 0 shifts
	; C is clear because 8-X top bits will be zero
	; 43+15*#bits / 31+15*#bits
	; 1 bits = 58 cycles, 8 bits = 163 cycles (~20 cycles/bit)
; (UnZip: 23+45*#bits)
	.pend


;--------------- Output/buffer routines ---------------------


	; 70+12 cycles/byte (w/ CRC32)
PutBuffer
	sty puty+1	;4
	inc outSize+0	; (256*9+(256*8+(256*8+5)/256)/256)/256
	bne u0		;  = 9.0314 cycles/byte
	inc outSize+1
	bne u0
	inc outSize+2
	bne u0
	inc outSize+3
u0

outCmd	sta $aaaa



	; updcrc()
	; (crc32_tab[((int)crc ^ cp) & 255] ^ (crc >> 8))
	eor CRC+0		; 3
	tay			; 2
	lda crc32_tab0,y	; 4
	eor CRC+1		; 3
	sta CRC+0		; 3
	lda crc32_tab1,y	; 4
	eor CRC+2		; 3
	sta CRC+1		; 3
	lda crc32_tab2,y	; 4
	eor CRC+3		; 3
	sta CRC+2		; 3
	lda crc32_tab3,y	; 4
	sta CRC+3		; 3	=42 cycles/byte = ~7.5 secs for 170.75kB

	inc outCmd+1	;6
	bne u2		;2/3
	inc outCmd+2
	lda outCmd+2
	cmp #>(buf32k+bufsz)
	bne u2
	; Save buffer data buffer32k .. (outCmd)
	jsr FlushBuffer
	jsr InitBuffer32k
u2
puty	ldy #0	; restore Y value
	rts


InitBuffer32k
	; Init buffer pointer
	lda #<buf32k
	sta outCmd+1
	lda #>buf32k
	sta outCmd+2
	rts



	; Implode expects a cleared buffer
ClearBuffer .proc
	lda #<buf32k
	sta b0+1
	lda #>buf32k
	sta b0+2

	lda #0
	tay
b0	sta $aa00,y
	iny
	bne b0
	inc b0+2
	ldx b0+2
	cpx #>(buf32k+bufsz)
	bne b0
	rts
        .pend


FlushBuffer     ; Can trash A & Y, X
	lda mode
	cmp #"N"	; skip it
	bne doh
	rts
doh

	jsr onoff
        
        .comment
	lda d64mode
	beq noh
	jsr writebuf
	jsr CLRCHN
	jsr onoff

	rts
	.endc


;noh
	ldx #3
	jsr CHKOUT	; (sends LISTEN+SECOND)

	lda #<buf32k
	sta bTmp+0
	lda #>buf32k
	sta bTmp+1



;	lda IDE64present
;	bpl noIDE64hereh	; IDE64 not found
	lda outCmd+1
	sec
	sbc bTmp+0
	tax
	lda outCmd+2
	sbc bTmp+1
	tay
	lda #bTmp
	inc $d020
	jsr IDE64BlockWrite
	bcc IDE64writebackh	;Tried to write to a floppy...
;noIDE64hereh

	ldx #3
	jsr CHKOUT	; (sends LISTEN+SECOND)

h1	lda bTmp+0
	cmp outCmd+1
	bne h0
	lda bTmp+1
	cmp outCmd+2
	bne h0

IDE64writebackh

	jsr CLRCHN
	jmp onoff


h0

	ldy #0
	lda (bTmp),y

	sta $d020
	jsr CHROUT

	inc bTmp+0
	bne h1
	inc bTmp+1
	jmp h1



;--------------- Huffman routines ---------------------


;================================================================
;
; struct HufNode
; 0	0-bit value LSB
; 1	0-bit value MSb (D0) + leaf flag (D7)
; 2	1-bit value LSB				or jump LO
; 3	1-bit value MSb (D0) + leaf flag (D7)	or jump HI (D7=0)


;UnZip: create huffman codes 299 bytes (gunzip 397(new 202) bytes)


IsPat   .proc
	; Check if there is another code of the current length
	;    while (1) {
	;	if (fpos[len] >= fmax)
	;	    return -1
	;	if (flens[fpos[len]] == len)
	;	    return fpos[len]++
	;	fpos[len]++
	;    }
	lda len
	asl
	tax

loopt	ldy fpos+0,x
	lda fpos+1,x	; fpos[len]
	cmp numval+1
	bcc t0
	cpy numval+0
	beq nott

t0	cmp #0		; HI
	bne t1
	lda (lengths),y
	jmp t2

t1	inc lengths+1	; next page
	lda (lengths),y
	dec lengths+1
t2	cmp len
	bne inct
	; got it
	lda fpos+1,x
	lsr		; shift HI to C
	tya		; LO to A
	inc fpos+0,x
	bne t3
	inc fpos+1,x
t3	ldx #0		; return zero set (and negative clear)
	rts

inct	inc fpos+0,x
	bne loopt
	inc fpos+1,x
	bpl loopt

nott	ldx #128	; return zero clear (and negative set)
	rts
        .pend


	; Create a decode tree that is in (Places)
	; Number of values in A(lo) and Y(hi)
	; Length table pointer in (lengths)
CreateTree
	sta numval+0
	sty numval+1

	lda #0
	sta len
	ldx #2*17-1	; clear the index counters
p0	sta fpos,x
	dex
	bpl p0


; Recursive function
; max recursion depth is equal to the length of the longest codeword (16?)
; four bytes of stack are used for each recursion (4*16 = 64)
Rec	lda len
	cmp #17
	bne okp
	inc ferr	; invalid huffman tree
	; Z clear
	rts

okp	lda curplace+0	; Save old curplace
	pha
	lda curplace+1
	pha

	lda Places+1
	sta curplace+1
	lda Places+0
	sta curplace+0	; curplace = Places
	clc
	adc #4		; Places++
	sta Places+0
	bcc o0
	inc Places+1
o0	inc len		; len++

	jsr IsPat	; Is there a code of this length?
	bne notzrp
	; Yes: set leaf node indicator and value
	ldy #0
	sta (curplace),y	; 0-branch LSB
	lda #$40
	rol			; <-C	$80+C	leaf cell + MSb
	iny
	sta (curplace),y	; 0-branch MSb
	bpl onep	; jump always
notzrp	; No: clear the leaf node indicator and
	;     create the 0-bit subtree recursively
	ldy #1
	tya	;lda #0		; non-negative is enough
	sta (curplace),y	; not a leaf cell
	jsr Rec
	jmp notonep	; will not find a code because there was none left

onep	jsr IsPat	; Is there a code of this length?
	bne notonep
	; Yes: set leaf node indicator and value
	ldy #2
	sta (curplace),y	; 1-branch LSB
	lda #$40
	rol			; <-C	$80+C	leaf cell + MSb
	iny
	sta (curplace),y	; 1-branch MSb
	bpl outp
notonep	; No: set jump address and
	;     create the 1-bit subtree recursively
	ldy #3
	lda Places+1		; not a leaf cell
	sta (curplace),y	; (must be in lower half of the mem)
	dey
	lda Places+0
	sta (curplace),y
	jsr Rec

outp	dec len			; len--
	; Restore curplace
	pla
	sta curplace+1
	pla
	sta curplace+0
	lda ferr	; Z set/clear
	rts



; UnZip: 0-bit 27+13 1-bit 46+13 ->36.5+13	(gunzip 31/39-5 ->35-5)
	; 48 bytes				(gunzip 56 bytes)


	; Decode a value using a tree that is in A(lo) and Y(hi)
	; 12(jsr+rts) + 6 + ~34 cycles / decoded bit
DecodeValue .proc
	sta curplace+0		; 3
	sty curplace+1		; 3
whiler	; GetBit Note: does not need to save A nor X!!
	lsr bb			; 5
	beq morer		; 2 /3
	bcc zeror		; 2/3	zero:~30	one:~38
	; A one-bit		;	last:~29+6	last:~28+6
oner	ldy #3			; 2
	lda (curplace),y	; 5*
	bmi return		; 2/3
	tax			;2
	dey			;2
	lda (curplace),y	;5*
	sta curplace+0		;3
	stx curplace+1		;3
	bcs whiler
	;jmp while$		;3 =18

morer	jsr GetByte
	sec
	ror
	sta bb
	bcc zeror
	bcs oner

zeror	ldy #1			; 2
	lda (curplace),y	; 5*
	bmi return		; 2/3
	lda curplace+0		; 3
	;clc
	adc #4			; 2
	sta curplace+0		; 3
	bcc whiler		; 2/3
	inc curplace+1		; 5
	bcs whiler
	;jmp while$		; 3

	; return curplace->b1 or curplace->b0
        .pend
        
return	.proc
	lsr			; 2  MSb to C
	dey			; 2
	lda (curplace),y	; 5* LSB to A
	rts			; 6
	.pend


	; Decode a value using a tree that is in A(lo) and Y(hi)
	; ~35 cycles / decoded bit
DecodeSFValue .proc			; can change ROM
	sta curplace+0		; 3
	sty curplace+1		; 3
whilee	; GetBit Note: does not need to save A nor X!!
	lsr bb			; 5
	bne r1			; 2/3
	jsr GetByte
	sec
	ror
	sta bb
r1	bcs zeroe		; 2/3	zero:~31	one:~39
	; A one-bit		;	last:~30+6	last:~29+6
	ldy #3			; 2
	lda (curplace),y	; 5*
	bmi return		; 2/3
	tax			;2
	dey			;2
	lda (curplace),y	;5*
	sta curplace+0		;3
	stx curplace+1		;3
	bcc whilee
	;jmp while$		;3 =18

zeroe	ldy #1			; 2
	lda (curplace),y	; 5*
	bmi return		; 2/3
	lda curplace+0		; 3
	;sec
	adc #3			; 2
	sta curplace+0		; 3
	bcc whilee		; 2/3
	inc curplace+1		; 5
	bcs whilee
	;jmp while$		; 3
	.pend





;--------------- Misc utility routines ---------------------


puthex	.proc
	pha
	lsr
	lsr
	lsr
	lsr		; 0..9 -> $30..$39, A..F -> $41..$46

	cmp #10
	bcc d1
	adc #$70-10
d1	eor #$30

	jsr CHROUT
	pla
	and #15

	cmp #10
	bcc d2
	adc #$70-10
d2	eor #$30
	jmp CHROUT
        .pend

showsize .proc
	sta d0+1
	sty d0+2
	jsr CLRCHN
	ldx #3
d0	lda $aaaa,x
	bne d1
	cpx #3
	beq d2		; do not show the first "00"
d1	jsr puthex
d2	dex
	bpl d0
	rts
        .pend

onoff	lda $d011
	eor #$10
	sta $d011
	rts

putstr	.proc
	cpy #0
	beq d2
	stx d0+1
	sta d0+2
	sty d1+1
	jsr CLRCHN
	ldy #0
d0	lda $aaaa,y
	jsr CHROUT
	iny
d1	cpy #0
	bne d0
d2	rts
	.pend


getstr	.proc
	sta d0+1	; <buffer
	sta d2+1
	stx d0+2	; >buffer
	stx d2+2
	sty d1+1	; maxlen+1
	jsr CLRCHN
	ldy #0
d0	lda $aaaa,y
	beq editd
	jsr CHROUT
	iny
	bne d0

editd	sty d3+1
	jsr getkey
d3	ldy #0
	bcs editd
	cmp #13		; return
	beq quitd
	cmp #157	; cursor left
	beq bsd
	cmp #20		; backspace
	bne no8d
bsd	cpy #0
	beq editd
	jsr CHROUT	; <- destructive bs?
	dey
	jmp editd
no8d	cmp #32
	bcc editd	; 0..31
d1	cpy #0
	beq editd	; no more room
d2	sta $aaaa,y
	jsr CHROUT
	iny
	jmp editd
quitd	rts
	.pend

getkey	.proc
	jsr CLRCHN
	jsr GETIN
	clc
	bne okd
	sec
okd	rts
	.pend

geterror .proc       ; read the disk error channel - channel in X
	jsr CHKIN
	jsr CHRIN	; read the first digit
	sta errorStr+0
	and #15
	tax		; and store it
	jsr CHRIN	; read the second digit
	sta errorStr+1
	and #15
	clc
	adc tentimes,x
	sta errorCode
	pha
	;beq skip$	; no error -> do not read the rest
	ldy #2
f2	jsr CHRIN
	sta errorStr,y
	iny
	cmp #$0d	; IDE64 does not set ST at the end of the error string
	beq f3
	lda ST		; READST
	beq f2
f3	sty errorLen
	jsr CLRCHN	; clear the channel
	pla
	rts		; return (error code in accumulator)
	.pend


;sectorsPerTrack
;	.byte 21,21,21,21,21,21,21,21	;1..8
;	.byte 21,21,21,21,21,21,21,21	;9..16
;	.byte 21,19,19,19,19,19,19,19	;17..24
;	.byte 18,18,18,18,18,18,17,17	;25..32
;	.byte 17,17,17			;33..35
	;dc.b 21,21,21,21,21,21,21,21	;36..43
	;dc.b 21,21,21,21,21,21,21,21	;44..51
	;dc.b 21,19,19,19,19,19,19,19	;52..59
	;dc.b 18,18,18,18,18,18,17,17	;60..67
	;dc.b 17,17,17			;68..70

;oTrack	.byte 1
;oSector	.byte 0
;oPages	.byte 0


putval	.proc
	pha		; 0..99 decimal
	lda #" "
	jsr CHROUT
	pla

	ldx #0
f1	cmp #10
	bcc f0
	inx
	sec
	sbc #10
	jmp f1
f0	cpx #0
	beq f2		; turn off leading zero
	pha
	txa
	clc
	adc #"0"
	jsr CHROUT
	pla
f2	clc
	adc #"0"
	jmp CHROUT
	.pend


        .comment
writebuf
	lda #<buf32k
	sta bTmp+0
	lda #>buf32k
	sta bTmp+1
	lda outCmd+2
	sec
	sbc #>buf32k
	sta oPages

; ===============================


wrloopk	lda oPages
	bne wrcntk
	rts

nosectork
	lda #0
	sta oSector
	inc oTrack

wrcntk	lda d64mode

	cmp #8
	bne d7141k
	lda oSector
	cmp #40
	beq nosectork	; no sector 40 -> next track, sector 0
	bne yessectork

d7141k	lda oTrack
	cmp #36
	bcc cmpk	; 1..35
	sbc #35		; 36..70 -> 1..35
cmpk	tax
	lda oSector
	cmp sectorsPerTrack-1,x
	bcs nosectork
yessectork
	; Write the block @oScnt into oTrack / oSector + oScnt
; ===============================

	lda outBurst
	beq nobk
againk	jsr BSAVE	; can perform burst write -> did not open file
	lda status
	and #15
	cmp #2
	bcc nextk
	cmp #11
	bne berrk
	ldx #15
	jsr BINQ
	jmp againk

berrk	ldx oTrack
	lda oSector
	jsr BERR
	lda #13
	jsr CHROUT
	jmp nextk

nobk	ldx #3
	jsr CHKOUT	;(sends LISTEN+SECOND)

	ldy #0
sendk
	lda (bTmp),y

	sta $d020
	jsr CHROUT

	iny
	bne sendk
	jsr CLRCHN

	ldx #15
	jsr CHKOUT
	lda #"U"
	jsr CHROUT
	lda #"2"
	jsr CHROUT
	lda #" "
	jsr CHROUT
	lda #"3"	; channel
	jsr CHROUT
	lda #" "
	jsr CHROUT
	lda #"0"	; unit
	jsr CHROUT

	lda oTrack	; track
	jsr putval
	lda oSector	; sector
	jsr putval
	jsr CLRCHN

	lda #14
	sta $d020

	ldx #15
	jsr geterror	; waits until the write is finished..
	cmp #0
	beq noerrk
	jmp diskerror
noerrk

nextk	inc bTmp+1
	dec oPages
	inc oSector
	jmp wrloopk


initbp	pha
	ldx #15
	jsr CHKOUT
	lda #"B"
	jsr CHROUT
	lda #"-"
	jsr CHROUT
	lda #"P"
	jsr CHROUT
	lda #" "
	jsr CHROUT
	pla
	jsr CHROUT
	lda #" "
	jsr CHROUT
	lda #"0"
	jsr CHROUT
	jmp CLRCHN

	.endc



prns	.proc
	jsr CLRCHN
	pla
	sta addr+1
	pla
	sta addr+2
loop	inc addr+1
	bne addr
	inc addr+2
addr	lda $aaaa
	beq out
	jsr CHROUT
	jmp loop
out	lda addr+2
	pha
	lda addr+1
	pha
	rts
        .pend



;--------------- Directory scan/list routine ---------------------

dir	.byte "$0:*"
fname	.byte 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0
fnameln	.byte 0
ftype	.byte 0
ftrack	.byte 0
fsector	.byte 0
fblocks	.byte 0,0
ftypstr	.byte "SEQ PRG USR REL CBM ?6? ?7? "
fcount	.byte 0
fdos	.byte 0
fflag	.byte 0
fdtype	.byte 0

	.comment
I0	; command channel in X
	jsr CHKOUT
	lda #"I"
	jsr CHROUT
	lda #"0"
	jsr CHROUT
	jmp CLRCHN
        .endc


ReadDir	
	;ldx #14
	;jsr I0
	lda #0
	sta fcount
	sta fdtype

	; Open directory
	ldx #<dir
	ldy #>dir
	lda #4
	jsr SETNAM

	lda #2		; first try raw directory
	ldx inDrive
	ldy #2		; open 2,8,2,"$0:*"
	jsr SETLFS
	jsr OPEN
	lda ST
	beq l2

	lda #2
	jsr CLOSE

	lda #2		; could not open raw, try normal directory
	ldx inDrive
	ldy #0		; open 2,8,0,"$0:*"
	jsr SETLFS
	jsr OPEN

	inc fdtype

	lda ST
	beq l2

;quit0l 
	lda #2
	jsr CLOSE
	jsr CLRCHN

	ldx #14
	jsr geterror
	ldx #<errorStr
	lda #>errorStr
	ldy errorLen
	jmp putstr

l2	ldx #2
	jsr CHKIN
	jsr CHRIN	; get disk format "A" for 1541/51/71/4040 or "D" for 1581
	sta fdos
	jsr CHRIN
	sta fflag
	cmp #$04
	bne notidel
	lda fdos
	cmp #$01
	bne notidel
	; probably IDE64 or some other device that does not support
	; raw directories
	inc fdtype

	ldy #5
is0l	jsr CHRIN
	dey
	bne is0l	; skip line link, line number, reverse

is1l	jsr CHRIN
	cmp #0		; skip the rest of the line
	bne is1l
	jsr CLRCHN
	jmp dirloopl

notidel
	ldy #252
skipl	jsr CHRIN
	dey
	bne skipl	; skip disk info
	jsr CLRCHN

dirloopl
	ldx #2
	jsr CHKIN

	lda fdtype
	bne ide2l
	jmp noide2l

ide2l	jsr CHRIN	; skip line link
	jsr CHRIN

	jsr CHRIN
	sta fblocks+0
	jsr CHRIN
	sta fblocks+1

is3l	jsr CHRIN
	tax
	beq retl	; xx BLOCKS FREE.	-- zero before quote
	lda ST
	bne retl
	cpx #34
	bne is3l

	ldy #0
is4l	jsr CHRIN	; name
	cmp #34
	beq is5l
	sta fname,y
	iny
	cpy #17
	bne is4l
	dey
is5l	lda #0
	sta fname,y
	sty fnameln

is6l	jsr CHRIN
	iny
	cpy #18
	bne is6l

	ldx #$81
	cmp #"S"	; "SEQ"
	beq is7l
	inx
	cmp #"P"	; "PRG"
	beq is7l
	inx
	cmp #"U"	; "USR"
	beq is7l
	inx
	cmp #"R"	; "REL"
	beq is7l
	inx
	cmp #"C"	; "CBM"
	beq is7l
	cmp #"D"	; "DIR" (IDE64)
	beq is7l
	ldx #$80	; "DEL"
is7l
	stx ftype

is8l	jsr CHRIN
	ldx ST
	bne retl
	tax	; cmp #0
	bne is8l
	sta ftrack
	sta fsector
	jmp noskipl

retl	lda #2
	jsr CLOSE
	jmp CLRCHN	; jsr + rts

noide2l	jsr CHRIN	; file type	0
	sta ftype
	lda ST
	and #$c0
	beq okl

	lda #2
	jsr CLOSE
	jmp CLRCHN	; jsr + rts


okl	jsr CHRIN	; track		1
	sta ftrack
	jsr CHRIN	; sector	2
	sta fsector
	ldy #0		; 16
nameloopl
	jsr CHRIN	; name		3-18 (0-15)
	cmp #$a0
	beq nameendl
	sta fname,y
	iny
	cpy #16
	bne nameloopl
	lda #0
	sta fname,y
	sty fnameln
	jmp otherl
nameendl
	lda #0
	sta fname,y
	sty fnameln
	iny
otherl	jsr CHRIN	; skip the rest of the filename & other fields
	iny
	cpy #25		; 19-27 (16-24)
	bne otherl
	jsr CHRIN	; blocks lo	28
	sta fblocks+0
	jsr CHRIN	; blocks hi	29
	sta fblocks+1

	inc fcount
	lda fcount
	and #7
	beq noskipl
	jsr CHRIN	; 'link'	30
	jsr CHRIN	; 'link'	31
noskipl
	jsr CLRCHN
	lda ftype
	and #7
	bne contl
	jmp dirloopl	; skip DELeted files

contl	ldy inLen	; if no file specified, ask the user
	beq askl	; if file specified, compare and return..

	cpy fnameln	; 21 bytes
	beq cnamel
	jmp dirloopl	; lengths do not match, no need to check more

cnamel	lda fname-1,y
	cmp inFile-1,y
	beq l12
	jmp dirloopl	; name does not match
l12	dey
	bne cnamel

	; name matches
gotitl

;	lda ftrack
;	sta inTrack
;	lda fsector
;	sta inSector


	lda #2
	jmp CLOSE	; jsr + rts

askl

	lda fblocks+1
	jsr puthex
	lda fblocks+0
	jsr puthex
	lda #" "
	jsr CHROUT
	lda ftype
	and #7
	asl
	asl	; *4
	clc
	adc #<(ftypstr-4)
	tax
	lda #>(ftypstr-4)
	adc #0
	ldy #3
	jsr putstr

	ldx #32
	lda ftype
	bmi closedl
	ldx #"*"
closedl
	txa
	jsr CHROUT

	lda #34
	jsr CHROUT
	ldx #<fname
	lda #>fname
	ldy fnameln
	jsr putstr
	lda #34
	jsr CHROUT
	ldy fnameln
tasaal	lda #" "
	jsr CHROUT
	iny
	cpy #17
	bne tasaal

	jsr prns
	.byte 18,"Y",146," ",18,"N",146," ",18,"Q",146," ?", 0

ackl	jsr getkey
	bcs ackl
	cmp #"Y"
	beq thisl
	cmp #3
	beq quitl
	cmp #"Q"
	beq quitl
	cmp #"N"
	bne ackl

	jsr OK_KEY
	jmp dirloopl

quitl	jsr CLRCHN
	jsr OK_KEY
	lda #0
	sta ftrack
	jmp gotitl

thisl	jsr OK_KEY
	ldy #0
cpl	lda fname,y
	sta inFile,y
	iny
	cpy fnameln
	bne cpl
	sty inLen
	jmp gotitl




askdrive
	sta chanf+1
	jsr prns
	.byte " DRIVE? ",18,"8",146,"-",18,"9",146,",1",18,"0",146,"-1",18,"7",146,0

askf	jsr getkey
	bcs askf
	cmp #"0"
	bcc askf	; smaller than "0"
	cmp #":"
	bcs askf	; ":" or greater
	sec
	sbc #"0"
	cmp #8
	bcs ookf
	;clc
	adc #10	; 0..7 becomes 10..17, 8..9 stays 8..9
ookf	sta drivef+1

	jsr putval
	jsr CR

askd	lda #0
	jsr SETNAM
chanf	lda #15
	pha
drivef	ldx #8
	ldy #15		; open chan,drive,15
	jsr SETLFS
	jsr OPEN

	pla
	jsr CLOSE
	lda ST		; READST
	;cmp #0
	bne nokf
	jsr OPEN	; reopen
	lda drivef+1
	rts
nokf	lda #0
	rts



OK_KEY	jsr CHROUT
CR	lda #13
	jmp CHROUT


	.comment
BREAD	.proc
	sty ye+1
	ldx #$c0	; 1581 BURST: LEXS000N	L=logical t&s
	lda fdos
	cmp #"A"
	bne e2
	; 1541/1571/4040-format disks
	ldx #$40	; 1571 BURST: TEBS000N	T=no transfer
e2	stx cmdline+2

	LDA inTrack
	STA cmdline+3
	LDA inSector
	STA cmdline+4
	LDA #1
	STA cmdline+5

	LDA #6
	STA cmdlen
	ldx #14
	JSR sendcmd

	SEI
	BIT D1ICR

	LDA D2PRA
	EOR #CLKOUT
	STA D2PRA

e1	LDA #8
w1e	BIT D1ICR
	BEQ w1e
	LDA D1SDR
	STA status

	and #15
	cmp #11		; disk changed -> no data
	beq e5

	LDA D2PRA
	EOR #CLKOUT
	STA D2PRA

	ldy #0
e3	LDA #8
e4	BIT D1ICR
	BEQ e4

	LDA D2PRA
	EOR #CLKOUT
	STA D2PRA

	LDA D1SDR
	sta inBuf,y
	sta $d020
	INY
	BNE e3

e5	cli
ye	ldy #0
	RTS
        .pend


BSAVE	.proc
	lda d64mode
	cmp #8
	bne d6471q
	lda #$82
	.byte $2c
d6471q	LDA #$02	; logical write: $82 for 1581, $02 for 157x
	STA cmdline+2

	LDA oTrack
	STA cmdline+3
	LDA oSector
	STA cmdline+4
	LDA #1
	STA cmdline+5

	LDA #$06
	STA cmdlen
	ldx #15
	JSR sendcmd

	LDA #$40
	STA oldclkq+1

	LDY #0
	SEI
q1	SEC
	JSR SPIN_OUT

q2      LDA D2PRA
oldclkq	EOR #0
	AND #$40
	BEQ q2		; wait for a change in clock

	LDA (bTmp),Y
	STA D1SDR	; immediately send the next byte
	sta $d020

	LDA oldclkq+1
	EOR #$40
	STA oldclkq+1

	LDA #8
q4	BIT D1ICR
	BEQ q4		; wait until it has been sent

	INY
	BNE q2

	CLC
	JSR SPIN_OUT
	BIT D1ICR

	LDA D2PRA	; clk lo
	ORA #$10
	STA D2PRA

	LDA #8
w1q	BIT D1ICR
	BEQ w1q		; wait for a fast byte

	LDA D1SDR
	STA status

	LDA D2PRA	; clk hi
	AND #$EF
	STA D2PRA
	CLI
	RTS
        .pend


BERR	pha
	txa
	pha
	lda #"E"
	jsr CHROUT
	lda status
	jsr puthex
	lda #","
	jsr CHROUT

	lda status
	and #15
	tay
	lda ePtrLo,y
	sta strq+1
	lda ePtrHi,y
	sta strq+2
	ldy #0
strq	lda $aaaa,y
	beq endq
	jsr CHROUT
	iny
	bne strq
endq
	lda #","
	jsr CHROUT
	lda #"$"
	jsr CHROUT
	pla
	jsr puthex
	lda #","
	jsr CHROUT
	lda #"$"
	jsr CHROUT
	pla
	jsr puthex
	lda #13
	jmp CHROUT

e0	.byte "OK",0
e1	.byte "SELECTED PARTITION",0
e2	.byte "NO SECTOR",0
e3	.byte "NO SYNC",0
e4	.byte "NO DATA BLOCK",0
e5	.byte "DATA CRC ERROR",0
e6	.byte "FORMAT ERROR",0
e7	.byte "VERIFY ERROR",0
e8	.byte "WRITE PROTECT",0
e9	.byte "HEADER CRC ERROR",0
e10	.byte "DATA EXTENDS INTO NEXT BLOCK",0
e11	.byte "DISK CHANGED",0
e12	.byte "DISK FORMAT NOT LOGICAL",0
e13	.byte "DISK CONTROLLER IC ERROR",0
e14	.byte "SYNTAX ERROR",0
e15	.byte "NO DISK",0

ePtrLo	.byte <e0,<e1,<e2,<e3,<e4,<e5,<e6,<e7,<e8,<e9,<e10,<e11,<e12,<e13,<e14,<e15
ePtrHi	.byte >e0,>e1,>e2,>e3,>e4,>e5,>e6,>e7,>e8,>e9,>e10,>e11,>e12,>e13,>e14,>e15

	; the channel number must be in X
BINQ	LDA #$04
	STA cmdline+2
	LDA #3
	STA cmdlen
	JSR sendcmd

	SEI
	BIT D1ICR

	LDA D2PRA
	EOR #CLKOUT
	STA D2PRA

	LDA #8
wait1d	BIT D1ICR
	BEQ wait1d

	LDA D1SDR
	STA status
        CLI
	RTS


cmdline
	.byte "U0", $80, 1, 1, 1, 1, 1, 1
cmdlen
	.byte 0
status
	.byte 0

sendcmd .proc
	JSR CHKOUT
	LDX #0
	LDY cmdlen
b1	LDA cmdline,x
	JSR CHROUT
	INX
	DEY
	BNE b1
	jmp CLRCHN
	.pend


CheckBurst .proc
	stx xd+1
	ldx #0
	stx FASTSER
	jsr myLISTEN
	lda #$6f
	jsr mySECOND
	lda #"U"
	jsr myCIOUT
	lda #"0"
	jsr myCIOUT
	jsr myUNLSN
	lda #0
	bit FASTSER
	bvc nobd
xd	ldx #14		; 1570/1571 seems to need this w/ C64+burst
	jsr BINQ
	lda #1
nobd	rts
	.pend

myLISTEN
	ora #$20
	pha
	bit $94			; C3PO - buffered char flag
	bpl q0
	sec
	ror $a3			; set no-ATN flag
	jsr myPB		; send buffered char
	lsr $94			; clear buffered char flag
	lsr $a3			; clear no-ATN flag
q0	pla
	sta $95			; set buffered character
	sei
	jsr ee97		; DOUT lo, release DATA

	lda $dd00
	and #$08
	bne q1
	jsr SPOUT		; SPOUT
	lda #$ff
	sta $dc0c
	jsr WAITSPIN
	txa
	ldx #20
q2	dex
	bne q2
	tax

q1	lda $dd00
	ora #$08
	sta $dd00		; ATNOUT hi, ATN low

myDEL	sei
	lda $dd00		; CLKOUT hi, CLK low
	ora #$10
	sta $dd00
	jsr ee97		; DOUT lo, release DATA
	txa			; DELAY937 delay for 937 cycles
	ldx #$b8
qc0	dex
	bne qc0
	tax

myPB	sei
	jsr ee97		; DOUT lo, release DATA
	jsr eea9		; wait settle, DATA->C
        bcc *+5
        jmp edad		;soci
;	bcs edad		; device not present
	bit $dc0d
	jsr ee85		; CLKOUT lo, release CLK
	bit $a3			; under ATN?
	bpl q3			;yes->wait for DATA up
	; not under ATN, wait for DATA up+down+up
q5	jsr eea9		; wait settle, DATA->C
	bcc q5			;wait for DATA released
q4	jsr eea9		; wait settle, DATA->C
	bcs q4			;wait for DATA low
q3	lda $dd00
	cmp $dd00
	bne q3
	pha
	lda $dc0d
	and #$08
	beq q6
	lda #$c0
	sta FASTSER
q6	pla
	bpl q3

	lda $dd00	; CLKOUT hi, CLK low
	ora #$10
	sta $dd00

	lda #$08
	sta $a5		; 8 bits to send
ed66	lda $dd00
	cmp $dd00
	bne ed66
	asl
	bcc edaf+1	;timeout read+write
	ror $95		; next bit to send
	bcs ed7a
	jsr eea0	; DOUT hi, DATA low
	bne ed7d
ed7a	jsr ee97	; DOUT lo, release DATA
ed7d
	jsr ee85	; CLKOUT lo, release CLK
	nop
	nop
	nop
	nop
	lda $dd00
	and #$df
	ora #$10
	sta $dd00	; release DATA, CLK low
	dec $a5
	bne ed66	;until 8 bits sent

	lda #$04
	sta $dc07	; timer B low byte
	lda #$19
	sta $dc0f	; force load, one-shot, run timer B
	lda $dc0d	; clear old interrupt bits
ed9f	lda $dc0d
	and #$02	; timer B expired?
	bne edaf+1	;timeout read+write
	jsr eea9	; wait settle, DATA->C
	bcs ed9f	;wait for ACK
	cli
	rts



edad	lda #$80	; device not present
edaf	bit $03a9	; timeout read+write
	ora ST
	sta ST
	cli
	clc
        jmp ee03	;soci
;	bcc ee03


mySECOND
	sta $95
	jsr myDEL	; CLKLODELAY
	lda $dd00
	and #$f7
	sta $dd00	; ATNOUT lo, ATN hi
	rts

myCIOUT
	bit $94
	bmi z0
	sec
	ror $94
	bne z1
z0	pha
	jsr myPB	; put buffered char
	pla
z1	sta $95
	clc
	rts

myUNLSN
	lda #$3f
	;pha
	;lda FASTSER
	;and #$7f
	;sta FASTSER
	;pla
	jsr myLISTEN+2
	jmp ee03

SPIN_OUT
	bcc SPIN
SPOUT	;lda #$7f
	;sta $dc0d
	lda #0
	sta $dc05
	lda #3		;$04
	sta $dc04
	lda $dc0e
	and #$80
	ora #$55
	sta $dc0e
	bit $dc0d
	rts
WAITSPIN
x0	lda $dc0d
	and #8
	beq x0
SPIN
	lda $dc0e
	and #$80	; preserve TOD mode, SP to input, timer A continuous
	ora #1
	sta $dc0e

	lda #$25        ; Set the normal (PAL) frequence to TimerA
	sta $dc04       ; Change if you want to preserve NTSC-rate
	lda #$40
	sta $dc05
	rts


ee97	lda $dd00	; DOUT lo, release DATA
	and #$df
	sta $dd00
	rts

eea0	lda $dd00	; DOUT hi, DATA low
	ora #$20
	sta $dd00
	rts

eea9	lda $dd00	; wait settle, DATA->C
	cmp $dd00
	bne eea9
	asl
	rts

ee03	lda $dd00
	and #$f7
	sta $dd00	; ATNOUT lo, ATN hi
	txa
	ldx #$0a
m0	dex
	bne m0
	tax
	jsr ee85	; CLKOUT lo, release CLK
	jmp ee97	; DOUT lo, release DATA

ee85	lda $dd00	; CLKOUT lo, release CLK
	and #$ef
	sta $dd00
	rts

CheckIDE64 .proc
	ldy #2
	lda $DF09	; check for Action Replay!
	cmp #$78	; SEI
	beq v1		; could be AR, must not read $DExx!
v0	lda $DE60,y
	cmp IDEID,y
	bne v1
	dey
	bpl v0
	lda #<inBuf
	sta IDE64BR+0
	lda #>inBuf
	sta IDE64BR+1
v1	sty IDE64present	; negative means IDE64 present
	rts

IDEID	.byte "IDE"
	.pend

	.endc



;d64mode	.byte 0		; 0 = file, 4 = D64 / D71, 8 = D81, $84 = one drive
;d64chan	.byte "#"
first	.byte 0

mode	.byte 0
overwritemode
	.byte 0
gzip	.byte 0

flags	.byte 0, 0
method	.byte 0, 0
inDrive	.byte 8
outDrive
	.byte 8

inLen		.byte 8

;inTrack		.byte 0
;inSector	.byte 0




border	; Order of the bit length code lengths
	.byte 16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15

cplens_3	; Copy lengths for literal codes 257..285 - 3
	.byte   3-3,   4-3,   5-3,   6-3,   7-3,   8-3,   9-3,  10-3
	.byte  11-3,  13-3,  15-3,  17-3,  19-3,  23-3,  27-3,  31-3
	.byte  35-3,  43-3,  51-3,  59-3,  67-3,  83-3,  99-3, 115-3
	.byte 131-3, 163-3, 195-3, 227-3, 258-3	;,   0,   0

cpdistLo	; Copy offsets for distance codes 0..29
	.byte $01, $02, $03, $04, $05, $07, $09, $0d
	.byte $11, $19, $21, $31, $41, $61, $81, $c1
	.byte $01, $81, $01, $01, $01, $01, $01, $01
	.byte $01, $01, $01, $01, $01, $01

cpdistHi	; Copy offsets for distance codes 0..29
	.byte $00, $00, $00, $00, $00, $00, $00, $00
	.byte $00, $00, $00, $00, $00, $00, $00, $00
	.byte $01, $01, $02, $03, $04, $06, $08, $0c
	.byte $10, $18, $20, $30, $40, $60

cplext	; Extra bits for literal codes 257..285
	.byte 0, 0, 0, 0, 0, 0, 0, 0
	.byte 1, 1, 1, 1, 2, 2, 2, 2
	.byte 3, 3, 3, 3, 4, 4, 4, 4
	.byte 5, 5, 5, 5, 0	;, 99, 99

cpdext	; Extra bits for distance codes
	.byte  0,  0,  0,  0,  1,  1,  2,  2
	.byte  3,  3,  4,  4,  5,  5,  6,  6
	.byte  7,  7,  8,  8,  9,  9, 10, 10
	.byte 11, 11, 12, 12, 13, 13

tentimes
	.byte 0,10,20,30,40,50,60,70,80,90

fileDef	.byte "STDOUT"

bitReverse
	*=*+256

;============================================================================
; Start of work space - variables

uncCRC	*=*+4

outSize	*=*+4

compSize
	*=*+4
uncSize
	*=*+4

fileLen	*=*+1

errorCode
	*=*+1
errorLen
	*=*+1
zfileLen
	*=*+2
zextraLen
	*=*+2



;outBurst
;	.byte 0
;inBurst
;	.byte 0

;inMode
;	.byte 0


;IDE64present
;	*=*+1


inFile
	*=*+30+4
errorStr
	*=*+56+4
fileName
	*=*+40+4

;inFile = $334
;errorStr = $334+30
;fileName = $334+30+56



Places	*=*+2
fpos	*=*+34
ferr	*=*+1

numval	*=*+2
len	*=*+1

literalCodes
	*=*+2
distCodes
	*=*+1

N
codelens
	*=*+320	; 288+32


;--------------- Space for the Huffman trees ---------------------


S
literalTree		; Note: has to be in lower half of the memory
	*=*+256*4

SPtrLo
impLengthTree		; Note: has to be in lower half of the memory
	*=*+32*4	; 256+32 for Deflate

	*=*+32*4	; 32 extra for Implode

SPtrHi
distanceTree		; Note: has to be in lower half of the memory


	*=*+32*4
	*=*+32*4	; 32 extra for Implode

	.if * > PROGEND
	.error program size overrun
	.fi

